ak47projectileHandler = {
	shellNum = 1,
	shells = {},
	defaultShell = {active = false}
}

ak47grenadeHandler = {
	shellNum = 1,
	shells = {},
	defaultShell = {active = false}
}

casing = {
	amount = 1,
	shells = {},
	defaultShell = {
		active = false,
		grenadeTimer = 0,
		boomTimer = 0,
		bounces = 0,
		pos = Vec(0,0,0),
		type = "casing",
		crot = 0
	}
}

function init()
	RegisterTool("saiga12", "Saiga-12", "MOD/vox/saiga12.vox", 3)
	SetBool("game.tool.saiga12.enabled", true)
	SetFloat("game.tool.saiga12.ammo", 101)

	damage = 0.15 * GetInt("savegame.mod.damage")/100
	if damage == 0 then
		damage = 0.15
	end
	gravity = Vec(0, -40, 0)
	velocity = 1
	maxMomentum = 0.8
	pelletSpread = 5
	pelletAmount = 8
	pelletDamage = damage

	inside = {}
	for i = 1,50 do
		inside[i] = {0,0,0,0}
	end
	hoverindex = 0

	gunsound = LoadSound("MOD/snd/ak0.ogg")
	suppressedgunsound = LoadSound("MOD/snd/aksuppressed.ogg")
	grenadelaunchersound = LoadSound("MOD/snd/grenadelauncher.ogg")
	toprail = GetString("savegame.mod.toprail")
	muzzle = GetString("savegame.mod.muzzle")
	stock = GetString("savegame.mod.stock")
	mag = GetString("savegame.mod.mag")
	grip = GetString("savegame.mod.grip")
	barrel = GetString("savegame.mod.barrel")
	side = GetString("savegame.mod.side")
	cocksound = LoadSound("MOD/snd/guncock.ogg")
	reloadsound = LoadSound("MOD/snd/reload.ogg")
	reloadsound2 = LoadSound("MOD/snd/reload2.ogg")
	dryfiresound = LoadSound("MOD/snd/dryfire.ogg")
	refillsound = LoadSound("MOD/snd/refill.ogg")
	selectsound = LoadSound("MOD/snd/selectorswitch.ogg")
	casingsound = LoadSound("MOD/snd/casingsound.ogg")
	interactsound1 = LoadSound("MOD/snd/interact1.ogg")
	interactsound2 = LoadSound("MOD/snd/interact2.ogg")
	uiselect = LoadSound("MOD/snd/uiselect.ogg")

	reloadTime = 2.4
	shotDelay = 0.125
	spreadTimer = 1.25
	spreadFactor = 1.5
	accuracyFactor = 1
	if mag == "" then
		magsize = 5
		reloadFactor = 1
	elseif mag == "mag1" then
		magsize = 10
		reloadFactor = 1.15
	elseif mag == "mag2" then
		magsize = 20
		reloadFactor = 1.35
	else
		magsize = 95
		reloadFactor = 1.5
	end
	barrellength = 0
	barrelFactorx = 0.8
	barrelFactory = 1.5
	barrelFactordamage = 1.25
	ammo = magsize
	grenadelauncherammo = 1
	mags = 2
	reloading = false
	ironsight = false
	ADSx = 0
	ADSy = 0
	ADSz = 0
	ADSrot = 0
	ADSfov = 0
	RELx = 0
	RELy = 0
	RELz = 0
	RELrotx = 0
	RELroty = 0
	RELrotz = 0
	SELx = 0
	SELy = 0
	SELz = 0
	SELrotx = 0
	SELroty = 0
	SELrotz = 0
	INSx = 0
	INSy = 0
	INSz = 0
	INSrotx = 0
	INSroty = 0
	INSrotz = 0
	sideattachment = false
	range = 0
	grenadelauncher = false
	unlimitedammo = GetBool("savegame.mod.unlimitedammo")
	spentcasingsoption = GetBool("savegame.mod.spentcasingsoption")

	for i=1, ammo*pelletAmount do
		ak47projectileHandler.shells[i] = deepcopy(ak47projectileHandler.defaultShell)
	end
	for i=1, 10 do
		ak47grenadeHandler.shells[i] = deepcopy(ak47projectileHandler.defaultShell)
	end

	shootTimer = 0
	reloadTimer = 0
	recoilTimer = 0
	recoilAngle = 0
	recoilFactor = 0
	stockFactor = 0
	muzzleFactor = 0
	gripfactorx = 0
	gripfactory = 0
	recoilMax = 0
	rnd1, rnd2, rnd3 = 0, 0, 0
	lightTimer = 0
	clickedmag = false
	animationTimers = {0, 0, 0, 0, 0}
	fovTimer = 0
	animation1Timer = 0

	magoutTimer = 0
	maginTimer = 0
	meleeTimer = 0
	cocksoundplaying = false
	reloadsound2playing = true
	selectsoundplaying = false
	selectattachments = false
	selectattachmentsTimer = 0
	inspectTimer = 0

	e = false
	q = false
	selectfire = 0
	selectfire0 = 2
	selectfireTimer = 0
	selectfireText = "Safe"

	despawnTime = 20
	casingGravity = Vec(0, -150, 0)
	throwVel = 50
end

function deepcopy(orig)
    local orig_type = type(orig)
    local copy
    if orig_type == 'table' then
        copy = {}
        for orig_key, orig_value in next, orig, nil do
            copy[deepcopy(orig_key)] = deepcopy(orig_value)
        end
        setmetatable(copy, deepcopy(getmetatable(orig)))
    else
        copy = orig
    end
    return copy
end

function GetAimPos()
	local ct = GetCameraTransform()
	local forwardPos = TransformToParentPoint(ct, Vec(0, 0, -100))
    local direction = VecSub(forwardPos, ct.pos)
    local distance = VecLength(direction)
	local direction = VecNormalize(direction)
	local hit, hitDistance = QueryRaycast(ct.pos, direction, distance)
	if hit then
		forwardPos = TransformToParentPoint(ct, Vec(0, 0, -hitDistance))
		distance = hitDistance
	end
	return forwardPos, hit, distance
end

function Shoot()
	if shootTimer > 0 or ammo == 0 then
		return
	end

	aimpos, hit, distance = GetAimPos()

	local gt = GetBodyTransform(GetToolBody())
	local fwdpos = TransformToParentPoint(gt, Vec(0.275, -0.55, -100))
	local gunpos = TransformToParentPoint(gt, Vec(0.275, -0.55, -2))
	dir = VecSub(fwdpos, gunpos)

	local maxSpread = InputDown("ctrl") and 1.5 or 3
	if ironsight then maxSpread = maxSpread / 3 end
	local spread = math.min(spreadTimer, maxSpread) * distance/100
	local factor = spreadFactor*spread*stockFactor*laserFactor*muzzleFactor*gripfactorx*barrelFactorx*2.25
	rnd1, rnd2, rnd3 = (math.random()-0.5)*factor, (math.random()-0.5)*factor, (math.random()-0.5)*factor

	if not ironsight then
		accuracyFactor = accuracyFactor*8
	end
	dir[1] = dir[1] + (math.random()-0.5)*accuracyFactor
	dir[2] = dir[2] + (math.random()-0.5)*accuracyFactor
	dir[3] = dir[3] + (math.random()-0.5)*accuracyFactor

	if recoilAngle < recoilMax then
		recoilAngle = recoilAngle + recoilFactor*muzzleFactor*gripfactory*barrelFactory
	end

	for i=1,pelletAmount do
	ak47projectileHandler.shells[ak47projectileHandler.shellNum] = deepcopy(ak47projectileHandler.defaultShell)
	loadedShell = ak47projectileHandler.shells[ak47projectileHandler.shellNum] 
	loadedShell.active = true
	loadedShell.pos = gunpos
	loadedShell.momentum = maxMomentum
	dir2 = VecAdd(dir, Vec((math.random()-0.5)*pelletSpread*barrelFactorspread,(math.random()-0.5)*pelletSpread*barrelFactorspread,(math.random()-0.5)*pelletSpread*barrelFactorspread))
	if muzzle == "muzzle1" then
		loadedShell.predictedBulletVelocity = VecScale(dir2, velocity*(150/distance)*barrelFactory)
	else
		loadedShell.predictedBulletVelocity = VecScale(dir2, velocity*(200/distance)*barrelFactory)
	end
	ak47projectileHandler.shellNum = (ak47projectileHandler.shellNum%#ak47projectileHandler.shells) + 1
	end

	SpawnParticle("fire", TransformToParentPoint(GetBodyTransform(GetToolBody()), Vec(0.25, -0.6, -2.35-barrellength*4/3)), VecScale(dir, 0.05), 0.3, 0.3)
	if muzzle == "muzzle1" then
		PlaySound(suppressedgunsound, GetPlayerTransform().pos, 1, false)
	elseif muzzle == "muzzle2" then
		PlaySound(gunsound, GetPlayerTransform().pos, 1, false)
	else
		PlaySound(gunsound, GetPlayerTransform().pos, 0.75, false)
	end

	if not unlimitedammo then
		ammo = ammo - 1
	end

	if selectfire == 1 then
		shootTimer = shotDelay
		recoilTimer = shotDelay
		lightTimer = shotDelay/2
		spreadTimer = spreadTimer + 1.25
	else
		shootTimer = 0
		recoilTimer = shotDelay
		lightTimer = shotDelay/2
		spreadTimer = spreadTimer + 1.25
	end

	if spentcasingsoption then
		SpentCasing()
	end
end

function ShootGrenade()
	if shootTimer > 0 or grenadelauncherammo == 0 then
		return
	end

	aimpos, hit, distance = GetAimPos()

	local gt = GetBodyTransform(GetToolBody())
	local fwdpos = TransformToParentPoint(gt, Vec(0.4, -1, -100))
	local gunpos = TransformToParentPoint(gt, Vec(0.4, -1, -2.2))
	dir = VecSub(fwdpos, gunpos)

	if recoilAngle < recoilMax then
		recoilAngle = recoilAngle + recoilFactor*muzzleFactor*gripfactory*barrelFactory
	end

	ak47grenadeHandler.shells[ak47grenadeHandler.shellNum] = deepcopy(ak47grenadeHandler.defaultShell)
	loadedShell = ak47grenadeHandler.shells[ak47grenadeHandler.shellNum]
	loadedShell.active = true
	loadedShell.pos = gunpos
	loadedShell.predictedBulletVelocity = VecScale(dir, 0.35*(300/distance))
	ak47grenadeHandler.shellNum = (ak47grenadeHandler.shellNum%#ak47grenadeHandler.shells) + 1

	SpawnParticle("fire", gunpos, Vec(0, 1.0+math.random(1,10)*0.1, 0), 0.3, 0.1)
	PlaySound(grenadelaunchersound, GetPlayerTransform().pos, 0.75, false)

	if not unlimitedammo then
		grenadelauncherammo = grenadelauncherammo - 1
	end
end

function ProjectileOperations(projectile)
	projectile.predictedBulletVelocity = VecAdd(projectile.predictedBulletVelocity, (VecScale(gravity, GetTimeStep())))
	local point2 = VecAdd(projectile.pos, VecScale(projectile.predictedBulletVelocity, GetTimeStep()))
	local dir = VecNormalize(VecSub(point2, projectile.pos))
	local hit, dist, normal, shape = QueryRaycast(projectile.pos, dir, VecLength(VecSub(point2, projectile.pos)))
	if hit then
		hitPos = VecAdd(projectile.pos, VecScale(VecNormalize(VecSub(point2, projectile.pos)), dist))
		point2 = hitPos
		DrawLine(projectile.pos, point2)
		local mat, r, g, b, a = GetShapeMaterialAtPosition(shape, hitPos)

		if mat == "metal" or mat == "heavymetal" or mat == "hardmetal" then
			bounceangle = 20
		else
			bounceangle = 10
		end

		local hitangle = math.acos(VecDot(projectile.predictedBulletVelocity, normal)/VecLength(projectile.predictedBulletVelocity))*57.3-90
		if hitangle < bounceangle and math.random(0, 100)/100 > (hitangle/bounceangle)^2 then
			PlaySound(bouncesound, projectile.pos, 1, false)
			local dot = VecDot(normal, projectile.predictedBulletVelocity)
			projectile.predictedBulletVelocity = VecSub(projectile.predictedBulletVelocity, VecScale(normal, dot*(1+math.random(1,10)/10)))
		else
			ApplyBodyImpulse(GetShapeBody(shape), hitPos, VecScale(projectile.predictedBulletVelocity, velocity/20))

			if mat == "glass" and math.random() > 0.65 then
				MakeHole(hitPos, 0.75)
				projectile.momentum = projectile.momentum - 0.2
			elseif mat == "metal" or mat == "heavymetal" or mat == "hardmetal" then
				SpawnParticle("smoke", hitPos, Vec(0, 1.0+math.random(1,10)*0.1, 0), damage, 1)
				ParticleReset()
				ParticleType("plain")
				ParticleTile(6)
				ParticleSticky(0, 0)
				ParticleRadius(0.01, 0.01)
				ParticleAlpha(1, 0)
				ParticleEmissive(10, 10)
				ParticleColor(1, 0.75, 0.25, 1, 0.25, 0.25)
				ParticleGravity(-10, -10)
				for i = 1, math.random(10, 15*maxMomentum) do
					SpawnParticle(hitPos, Vec((math.random(-100,100)/100)*5,(math.random(-100,100)/100)*5, (math.random(-100,100)/100)*5), math.random(10,25)/20)
				end
				PointLight(hitPos, 1, 0.75, 0.25, 0.25)
				projectile.momentum = projectile.momentum - 1
			else
				ParticleReset()
				ParticleType("plain")
				ParticleTile(6)
				ParticleSticky(0, 0)
				ParticleRadius(0.05, 0.05)
				ParticleAlpha(a, 0)
				ParticleEmissive(0, 0)
				ParticleColor(r, g, b, r, g, b)
				ParticleGravity(-10, -10)
				for i = 1, math.random(10, 15*maxMomentum) do
					SpawnParticle(hitPos, Vec((math.random(-100,100)/100)*5,(math.random(-100,100)/100)*5, (math.random(-100,100)/100)*5), math.random(10,25)/20)
					if mat == "dirt" then
						ParticleTile(1)
						ParticleRadius(0.5, 0.1)
						SpawnParticle(hitPos, Vec((math.random(-100,100)/100),(math.random(-100,100)/100)*5, (math.random(-100,100)/100)), math.random(10,25)/20)
					end
				end
				projectile.momentum = projectile.momentum - 0.5
			end

			local factor = barrelFactordamage

			MakeHole(hitPos, pelletDamage*factor, pelletDamage*0.85*factor, pelletDamage*0.7*factor)
		end
	else
		point2 = VecAdd(projectile.pos, VecScale(projectile.predictedBulletVelocity, GetTimeStep()))
		DrawLine(projectile.pos, point2)
	end
	
	if projectile.momentum < 0.1 or projectile.pos[2] < 0 then
		projectile.active = false
	end

	projectile.pos = point2
end

function GrenadeOperations(projectile)
	projectile.predictedBulletVelocity = VecAdd(projectile.predictedBulletVelocity, (VecScale(gravity, GetTimeStep())))
	local point2 = VecAdd(projectile.pos, VecScale(projectile.predictedBulletVelocity, GetTimeStep()))
	local dir = VecNormalize(VecSub(point2, projectile.pos))
	local hit, dist, normal, shape = QueryRaycast(projectile.pos, dir, VecLength(VecSub(point2, projectile.pos)))
	if hit then
		hitPos = VecAdd(projectile.pos, VecScale(VecNormalize(VecSub(point2, projectile.pos)), dist))
		Explosion(hitPos, 1)
	else
		point2 = VecAdd(projectile.pos, VecScale(projectile.predictedBulletVelocity, GetTimeStep()))
		DrawLine(projectile.pos, point2)
	end
	
	if hit then
		projectile.active = false
	end

	projectile.pos = point2
end

function Bouncing(projectile)
	projectile.predictedBulletVelocity = VecAdd(projectile.predictedBulletVelocity, (VecScale(projectile.gravity, GetTimeStep()/4)))
	local point2 = VecAdd(projectile.pos, VecScale(projectile.predictedBulletVelocity, GetTimeStep()/4))
	local dir = VecNormalize(VecSub(point2, projectile.pos))
	local distance = VecLength(VecSub(point2, projectile.pos))
	local hit, dist, normal = QueryRaycast(projectile.pos, dir, distance)
	if hit then
		PlaySound(casingsound, GetPlayerTransform().pos, 0.5/(projectile.bounces+1), false)
		if projectile.bounces == 6 then
			projectile.gravity = Vec(0, 0, 0)
			projectile.predictedBulletVelocity = Vec(0, 0, 0)
		else
			local dot = VecDot(normal, projectile.predictedBulletVelocity)
			projectile.predictedBulletVelocity = VecSub(projectile.predictedBulletVelocity, VecScale(normal, dot*1.4))
			projectile.bounces = projectile.bounces + 1
		end
	else
		projectile.pos = point2
	end
end

function Reload()
	if reloading or unlimitedammo then
		return
	end
	reloading = true
	if not grenadelauncher then
		PlaySound(reloadsound, GetPlayerTransform().pos, 0.5, false)
	end
	if grenadelauncher then
		if grenadelauncherammo == 0 then
			reloadTimer = reloadTime - 1
		end
		magoutTimer = 0.6
	else
		if ammo == 0 then
			reloadTimer = reloadTime
		else
			reloadTimer = reloadTime - 1
		end
		magoutTimer = 0.6
		mags = mags
	end
end

function SelectFire()
	selectfire = selectfire + 1
	if selectfire > 2 then
		selectfire = 0
	end
	selectfireTimer = 1

	selectfire0 = selectfire0 + 1
	if selectfire0 > 2 then
		selectfire0 = 0
	end
	selectsoundplaying = false
end

function Animate(transVariable, bool, animationTime, animateTransform, index)
	local dt = GetTimeStep()

	local animationTimer = animationTimers[index]

	if bool and animationTimer < animationTime then
		animationTimer = animationTimer*1.1 + dt
		if animationTimer >= animationTime then
			animationTimer = animationTime
		end
	elseif bool and animationTimer > animationTime then
		animationTimer = animationTimer*0.9 - dt/20
	elseif not bool and fovTimer > 0 then
		animationTimer = animationTimer*0.9 - dt/20
		if animationTimer < 0 then
			animationTimer = 0
		end
	end

	local x1 = animateTransform.pos[1]
	local y1 = animateTransform.pos[2]
	local z1 = animateTransform.pos[3]

	local rx1 = animateTransform.rot[1]
	local ry1 = animateTransform.rot[2]
	local rz1 = animateTransform.rot[3]

	local at = animationTimer / animationTime

	transVariable.pos = VecAdd(transVariable.pos, Vec(x1*at, y1*at, z1*at))
	transVariable.rot = QuatRotateQuat(transVariable.rot, QuatEuler(rx1*at, ry1*at, rz1*at))

	animationTimers[index] = animationTimer

	return transVariable
end

function SpentCasing()
	local ct = GetBodyTransform(GetToolBody())
	local fwdpos = TransformToParentPoint(ct, Vec(0.8+math.random(1,10)*0.01, -0.6+math.random(1,10)*0.01, -1.4+math.random(1,10)*0.01))
	local gunpos = TransformToParentPoint(ct, Vec(0.4, -0.6, -1.2))
	local direction = VecSub(fwdpos, gunpos)
	swingTimer = 0.125

	casing.shells[casing.amount] = deepcopy(casing.defaultShell)
	spentcasing = casing.shells[casing.amount];
	spentcasing.active = true
	spentcasing.type = casing

	spentcasing.sprite = LoadSprite("MOD/img/casing.png")

	spentcasing.pos = gunpos
	spentcasing.predictedBulletVelocity = VecScale(direction, throwVel)
	spentcasing.despawnTimer = despawnTime
	spentcasing.gravity = casingGravity

	casing.shells[casing.amount][6] = math.random(1,360)
	casing.amount = casing.amount + 1
end

function drawHint(info)
	UiPush()
		UiTranslate(info[1],info[2])
		local maxW=0
		for i=1,#info[8] do
			maxW=math.max(UiGetTextSize(info[8][i]),maxW)
			row=i 
		end
		UiTranslate(-((info[3]+maxW+12)/2+10)*info[6],-((info[4]+(10+row*20)+12)/2+10)*info[7])
		UiColor(0,0,0,info[5]*.5)
		--UiImageBox("ui/common/box-solid-6.png",maxW,10+row*20,6,6)
		UiColor(1,1,1,info[5])
		--UiImageBox("ui/common/box-outline-6.png",maxW,10+row*20,6,6) UiTranslate(0,(row-1)*-10)
		UiFont("bold.ttf",20)
		UiText(info[8][1])
		UiFont("regular.ttf",15)
		for i=2,row do
			UiTranslate(0,20)
			UiText(info[8][i])
		end
	UiPop()
end

function AttachmentButton(itemType,itemID,wantHint,location,Description,W,H)
	local clicked=false
	UiPush()
		local item=GetString("savegame.mod."..itemType)
		if item==itemID then
			UiColor(.5,1,.5,.5)
		else
			UiColor(0,0,0,.5)
		end
		local w,h=UiGetImageSize("MOD/icon/"..itemID..".png")
		local ww=W or w+12
		local wh=H or h+12
		UiImageBox("ui/common/box-solid-6.png",ww,wh,6,6)
		UiColor(1,1,1)
		UiImageBox("ui/common/box-outline-6.png",ww,wh,6,6)
		if UiImageButton("MOD/icon/"..itemID..".png")then
			clicked=true
			PlaySound(uiselect, GetPlayerTransform().pos, 1)
			if item == itemID then
				SetString("savegame.mod."..itemType, "")
			else
				SetString("savegame.mod."..itemType, itemID)
			end
		end
		if wantHint then
			hoverindex=hoverindex+1
			local hover,x,y=hovering(ww,wh,hoverindex)
			if hover > 0 then
				hint=true
				info={location[1],location[2],ww,wh,hover,x,y,Description}
			else
				hint=hint or false
			end
		end
	UiPop()
	return clicked,ww,wh
end

function hovering(w,h,index)
	local dt=GetTimeStep()
	if UiIsMouseInRect(w,h)then
		local x,y=UiGetMousePos()
		x=x/(w/2)
		y=y/(h/2)
		local scale=math.max(math.abs(x),math.abs(y))
		if scale ~= 0 then
			inside[index][3]=(x/scale)*.1+inside[index][3]*.9
			inside[index][4]=(y/scale)*.1+inside[index][4]*.9
		end

		if inside[index][1]>=1 then
			inside[index][2]=math.min(1,inside[index][2]+dt*2)
		else
			inside[index][1]=math.min(1,inside[index][1]+dt*2)
		end
	else
		inside[index][1]=math.max(0,inside[index][1]-dt*4)
		inside[index][2]=math.max(0,inside[index][2]-dt*4)
	end
	return inside[index][2],inside[index][3],inside[index][4]
end

function Laser(active)
		local gt = GetBodyTransform(GetToolBody())
		local gunpos = TransformToParentPoint(gt, Vec(0.175, -0.625, -1.9))
		local fwdpos = TransformToParentVec(gt, Vec(0, 0, -1))
		local hit, dist = QueryRaycast(gunpos, fwdpos, 500, 0, true)
		local hitpoint = VecAdd(gunpos, VecScale(fwdpos, dist))

		if active then
			SetShapeEmissiveScale(side1, 1)
			PointLight(hitpoint, 0, 1, 0, 0.2)
			DrawLine(gunpos, hitpoint, 0, 1, 0, 0.2)
			laserFactor = 0.9
		else
			SetShapeEmissiveScale(side1, 0)
			laserFactor = 1
		end
end
function Flashlight(active)
		local gt = GetBodyTransform(GetToolBody())
		local gunpos = TransformToParentPoint(gt, Vec(0.175, -0.625, -1.9))
		local fwdpos = TransformToParentVec(gt, Vec(0, 0, -1))
		local hit, dist = QueryRaycast(gunpos, fwdpos, 500, 0, true)

		if active then
			SetShapeEmissiveScale(side2, 1)
			PointLight(gunpos, 0.5, 0.5, 0.5, 0.1)
			for i = 1, dist*5 do
				local hitpoint = VecAdd(gunpos, VecScale(fwdpos, i/5))
				local b = 0.1
				PointLight(hitpoint, b/i^2.2, b/i^2.2, b/i^2.2, 2*i^2)
			end
		else
			SetShapeEmissiveScale(side2, 0)
		end
end
function Rangefinder(active)
		local gt = GetBodyTransform(GetToolBody())
		local gunpos = TransformToParentPoint(gt, Vec(0.175, -0.625, -1.9))
		local fwdpos = TransformToParentVec(gt, Vec(0, 0, -1))
		local hit, dist = QueryRaycast(gunpos, fwdpos, 500, 0, true)

		if active then
			range = dist
		else
			range = 0
		end
end

function ADS(bool, fov, fovTime, x, y, z, rot)
	local toolTrans = TransformToLocalTransform(GetCameraTransform(), GetBodyTransform(GetToolBody()))
	local toolx = toolTrans.pos[1]
	local tooly = toolTrans.pos[2]
	local toolz = toolTrans.pos[3]
	local rotx, roty, rotz = GetQuatEuler(toolTrans.rot)
	local toolrot = rotz

	local dt = GetTimeStep()*8/reloadFactor
	if grip == grip2 then
		dt = dt*1.25
	end

	if bool then
		if x > ADSx then 
			ADSx = ADSx + dt*math.abs((x-ADSx))
		elseif x < ADSx then
			ADSx = ADSx - dt*math.abs((x-ADSx))
		end
		if y > ADSy then 
			ADSy = ADSy + dt*math.abs((y-ADSy))
		elseif y < ADSy then
			ADSy = ADSy - dt*math.abs((y-ADSy))
		end
		if z > ADSz then 
			ADSz = ADSz + dt*math.abs((z-ADSz))
		elseif z < ADSz then
			ADSz = ADSz - dt*math.abs((z-ADSz))
		end
		if rot > ADSrot then 
			ADSrot = ADSrot + dt*math.abs((rot-ADSrot))
		elseif rot < ADSrot then
			ADSrot = ADSrot - dt*math.abs((rot-ADSrot))
		end
		if fov > ADSfov then 
			ADSfov = ADSfov + dt*math.abs((fov-ADSfov))
		elseif fov < ADSfov then
			ADSfov = ADSfov - dt*math.abs((fov-ADSfov))
		end
	end

	if not bool then
		if ADSx > 0.1 then 
			ADSx = ADSx - dt*math.abs((ADSx-0.1))
		elseif ADSx < 0.1 then
			ADSx = ADSx + dt*math.abs((ADSx-0.1))
		end
		if ADSy > 0.2 then 
			ADSy = ADSy - dt*math.abs((ADSy-0.2))
		elseif ADSy < 0.2 then
			ADSy = ADSy + dt*math.abs((ADSy-0.2))
		end
		if ADSz > 0.25 then 
			ADSz = ADSz - dt*math.abs((ADSz-0.25))
		elseif ADSz < 0.25 then
			ADSz = ADSz + dt*math.abs((ADSz-0.25))
		end
		if ADSrot > 0 then 
			ADSrot = ADSrot - dt*math.abs((ADSrot-0))
		elseif ADSrot < 0 then
			ADSrot = ADSrot + dt*math.abs((ADSrot-0))
		end
		if ADSfov > 0.25 then 
			ADSfov = ADSfov - dt*math.abs((ADSfov-0))
		elseif ADSz < 0.25 then
			ADSfov = ADSfov + dt*math.abs((ADSfov-0))
		end
	end

	local ADSvec = Vec(ADSx, ADSy, ADSz)

	local offset = Transform(Vec(0, 0, 0), QuatEuler(0, 0, ADSrot))
	offset.pos = VecAdd(offset.pos, ADSvec)
	SetCameraFov(GetInt("options.gfx.fov")-ADSfov+recoilTimer*5)

	return offset
end

function REL(bool, x, y, z, rotx, roty, rotz)
	local dt = GetTimeStep()*4/reloadFactor

	if bool then
		if x > RELx then 
			RELx = RELx + dt*math.abs((x-RELx))
		elseif x < RELx then
			RELx = RELx - dt*math.abs((x-RELx))
		end
		if y > RELy then 
			RELy = RELy + dt*math.abs((y-RELy))
		elseif y < RELy then
			RELy = RELy - dt*math.abs((y-RELy))
		end
		if z > RELz then 
			RELz = RELz + dt*math.abs((z-RELz))
		elseif z < RELz then
			RELz = RELz - dt*math.abs((z-RELz))
		end
		if rotx > RELrotx then 
			RELrotx = RELrotx + dt*math.abs((rotx-RELrotx))
		elseif rotx < RELrotx then
			RELrotx = RELrotx - dt*math.abs((rotx-RELrotx))
		end
		if roty > RELroty then 
			RELroty = RELroty + dt*math.abs((roty-RELroty))
		elseif rotx < RELroty then
			RELroty = RELroty - dt*math.abs((roty-RELroty))
		end
		if rotz > RELrotz then 
			RELrotz = RELrotz + dt*math.abs((rotz-RELrotz))
		elseif rotz < RELrotx then
			RELrotz = RELrotz - dt*math.abs((rotz-RELrotz))
		end
	end

	if not bool then
		if RELx > 0 then 
			RELx = RELx - dt*math.abs((RELx-0))
		elseif RELx < 0 then
			RELx = RELx + dt*math.abs((RELx-0))
		end
		if RELy > 0 then 
			RELy = RELy - dt*math.abs((RELy-0))
		elseif RELy < 0 then
			RELy = RELy + dt*math.abs((RELy-0))
		end
		if RELz > 0 then 
			RELz = RELz - dt*math.abs((RELz-0))
		elseif RELz < 0 then
			RELz = RELz + dt*math.abs((RELz-0))
		end
		if RELrotx > 0 then 
			RELrotx = RELrotx - dt*math.abs((RELrotx-0))
		elseif RELrotx < 0 then
			RELrotx = RELrotx + dt*math.abs((RELrotx-0))
		end
		if RELroty > 0 then 
			RELroty = RELroty - dt*math.abs((RELroty-0))
		elseif RELroty < 0 then
			RELroty = RELroty + dt*math.abs((RELroty-0))
		end
		if RELrotz > 0 then 
			RELrotz = RELrotz - dt*math.abs((RELrotz-0))
		elseif RELrotz < 0 then
			RELrotz = RELrotz + dt*math.abs((RELrotz-0))
		end
	end

	local RELvec = Vec(RELx, RELy, RELz)

	local offset = Transform(Vec(0, 0, 0), QuatEuler(RELrotx, RELroty, RELrotz))
	offset.pos = VecAdd(offset.pos, RELvec)

	return offset
end

function SEL(bool, x, y, z, rotx, roty, rotz)
	local dt = GetTimeStep()*4

	if bool then
		if x > SELx then 
			SELx = SELx + dt*math.abs((x-SELx))
		elseif x < SELx then
			SELx = SELx - dt*math.abs((x-SELx))
		end
		if y > SELy then 
			SELy = SELy + dt*math.abs((y-SELy))
		elseif y < SELy then
			SELy = SELy - dt*math.abs((y-SELy))
		end
		if z > SELz then 
			SELz = SELz + dt*math.abs((z-SELz))
		elseif z < SELz then
			SELz = SELz - dt*math.abs((z-SELz))
		end
		if rotx > SELrotx then 
			SELrotx = SELrotx + dt*math.abs((rotx-SELrotx))
		elseif rotx < SELrotx then
			SELrotx = SELrotx - dt*math.abs((rotx-SELrotx))
		end
		if roty > SELroty then
			SELroty = SELroty + dt*math.abs((roty-SELroty))
		elseif rotx < SELroty then
			SELroty = SELroty - dt*math.abs((roty-SELroty))
		end
		if rotz > SELrotz then
			SELrotz = SELrotz + dt*math.abs((rotz-SELrotz))
		elseif rotz < SELrotz then
			SELrotz = SELrotz - dt*math.abs((rotz-SELrotz))
		end
	end

	if not bool then
		if SELx > 0 then 
			SELx = SELx - dt*math.abs((SELx-0))
		elseif SELx < 0 then
			SELx = SELx + dt*math.abs((SELx-0))
		end
		if SELy > 0 then 
			SELy = SELy - dt*math.abs((SELy-0))
		elseif SELy < 0 then
			SELy = SELy + dt*math.abs((SELy-0))
		end
		if SELz > 0 then 
			SELz = SELz - dt*math.abs((SELz-0))
		elseif SELz < 0 then
			SELz = SELz + dt*math.abs((SELz-0))
		end
		if SELrotx > 0 then 
			SELrotx = SELrotx - dt*math.abs((SELrotx-0))
		elseif SELrotx < 0 then
			SELrotx = SELrotx + dt*math.abs((SELrotx-0))
		end
		if SELroty > 0 then 
			SELroty = SELroty - dt*math.abs((SELroty-0))
		elseif SELroty < 0 then
			SELroty = SELroty + dt*math.abs((SELroty-0))
		end
		if SELrotz > 0 then 
			SELrotz = SELrotz - dt*math.abs((SELrotz-0))
		elseif SELrotz < 0 then
			SELrotz = SELrotz + dt*math.abs((SELrotz-0))
		end
	end

	local SELvec = Vec(SELx, SELy, SELz)

	local offset = Transform(Vec(0, 0, 0), QuatEuler(SELrotx, SELroty, SELrotz))
	offset.pos = VecAdd(offset.pos, SELvec)

	return offset
end

function INS(bool, x, y, z, rotx, roty, rotz)
	local dt = GetTimeStep()*4

	if bool then
		if x > INSx then 
			INSx = INSx + dt*math.abs((x-INSx))
		elseif x < INSx then
			INSx = INSx - dt*math.abs((x-INSx))
		end
		if y > INSy then 
			INSy = INSy + dt*math.abs((y-INSy))
		elseif y < INSy then
			INSy = INSy - dt*math.abs((y-INSy))
		end
		if z > INSz then 
			INSz = INSz + dt*math.abs((z-INSz))
		elseif z < INSz then
			INSz = INSz - dt*math.abs((z-INSz))
		end
		if rotx > INSrotx then 
			INSrotx = INSrotx + dt*math.abs((rotx-INSrotx))
		elseif rotx < INSrotx then
			INSrotx = INSrotx - dt*math.abs((rotx-INSrotx))
		end
		if roty > INSroty then 
			INSroty = INSroty + dt*math.abs((roty-INSroty))
		elseif rotx < INSroty then
			INSroty = INSroty - dt*math.abs((roty-INSroty))
		end
		if rotz > INSrotz then 
			INSrotz = INSrotz + dt*math.abs((rotz-INSrotz))
		elseif rotz < INSrotx then
			INSrotz = INSrotz - dt*math.abs((rotz-INSrotz))
		end
	end

	if not bool then
		if INSx > 0 then 
			INSx = INSx - dt*math.abs((INSx-0))
		elseif INSx < 0 then
			INSx = INSx + dt*math.abs((INSx-0))
		end
		if INSy > 0 then 
			INSy = INSy - dt*math.abs((INSy-0))
		elseif INSy < 0 then
			INSy = INSy + dt*math.abs((INSy-0))
		end
		if INSz > 0 then 
			INSz = INSz - dt*math.abs((INSz-0))
		elseif INSz < 0 then
			INSz = INSz + dt*math.abs((INSz-0))
		end
		if INSrotx > 0 then 
			INSrotx = INSrotx - dt*math.abs((INSrotx-0))
		elseif INSrotx < 0 then
			INSrotx = INSrotx + dt*math.abs((INSrotx-0))
		end
		if INSroty > 0 then 
			INSroty = INSroty - dt*math.abs((INSroty-0))
		elseif INSroty < 0 then
			INSroty = INSroty + dt*math.abs((INSroty-0))
		end
		if INSrotz > 0 then 
			INSrotz = INSrotz - dt*math.abs((INSrotz-0))
		elseif INSrotz < 0 then
			INSrotz = INSrotz + dt*math.abs((INSrotz-0))
		end
	end

	local INSvec = Vec(INSx, INSy, INSz)

	local offset = Transform(Vec(0, 0, 0), QuatEuler(INSrotx, INSroty, INSrotz))
	offset.pos = VecAdd(offset.pos, INSvec)

	return offset
end

function tick(dt)
	if GetString("game.player.tool") == "saiga12" and GetPlayerVehicle() == 0 then
		if InputDown("lmb") and not reloading and selectfire == 1 and not selectattachments and selectfireTimer == 0 and GetPlayerGrabShape() == 0 and not InputDown("shift") and inspectTimer <= 0 then
			if grenadelauncherammo > 0 and grenadelauncher then
				ShootGrenade()
			elseif not grenadelauncher and ammo > 0 then
				Shoot()
			end
		elseif InputPressed("lmb") and not reloading and selectfire == 2 and not selectattachments and selectfireTimer == 0 and GetPlayerGrabShape() == 0 and not InputDown("shift") and inspectTimer <= 0 then
			if grenadelauncherammo > 0 and grenadelauncher then
				ShootGrenade()
			elseif not grenadelauncher and ammo > 0 then
				Shoot()
				shootTimer = 0.11
			end
		end

		if InputPressed("lmb") and not reloading and not InputDown("shift") and inspectTimer <= 0 then
			spreadTimer = 1.25
			if (ammo == 0 or selectfire == 0) and not selectattachments then
				PlaySound(dryfiresound, GetPlayerTransform().pos, 1, false)
			end
		end

		if InputReleased("lmb") and not reloading and selectfire > 0 then
			shootTimer = 0
		end

		
		if InputDown("rmb") and selectfire > 0 and selectfireTimer == 0 and not selectattachments and GetPlayerGrabShape() == 0 and not InputDown("shift") then
			if InputPressed("rmb") then
				PlaySound(interactsound1, GetPlayerTransform().pos, 1)
			end
			ironsight = true
			inspectTimer = 0
		end
		if InputReleased("rmb") then
			ironsight = false
		end
		if selectfire == 0 then
			ironsight = false
		end

		if InputPressed("e") then
			e = not e
			q = false
		end

		if InputPressed("q") then
			q = not q
			e = false
		end

		if InputPressed("x") and not reloading and not ironsight and shootTimer <= 0 and selectfire > 0 and stock ~= "removed" and not InputDown("shift") then
			meleeTimer = 0.8
		end

		if InputPressed("v") and not reloading and not selectattachments and not InputDown("shift") then
			SelectFire()
			inspectTimer = 0
		end

		if InputDown("t") and not reloading and selectfire > 0 and selectfireTimer <= 0 and not InputDown("shift") then
			if InputPressed("t") then
				PlaySound(interactsound2, GetPlayerTransform().pos, 1)
				selectattachmentsTimer = 0.5
			end
			UiMakeInteractive()
			selectattachments = true
			ironsight = false
			inspectTimer = 0
		end
		if InputReleased("t") and not reloading and selectfire > 0 and selectfireTimer <= 0 and not InputDown("shift") then
			selectattachments = false
			selectattachmentsTimer = 0.25
		end

		if InputPressed("b") and side ~= "" then
			sideattachment = not sideattachment
			PlaySound(uiselect, GetPlayerTransform().pos, 0.75)
		end
		Laser(sideattachment and side == "side1")
		Flashlight(sideattachment and side == "side2")
		Rangefinder(sideattachment and side == "side3")

		if InputDown("shift") then
			ironsight = false
			selectattachments = false
			inspectTimer = 0
		end

		if grip == "grenade_launcher" then
			if InputPressed("c") and not reloading then
				grenadelauncher = not grenadelauncher
			end
		else
			grenadelauncher = false
		end

		if InputPressed("g") and not reloading and not InputDown("shift") and selectfireTimer <= 0 and not ironsight and selectfire > 0 and not selectattachments then
			if inspectTimer <= 0 then
				inspectTimer = 6
				ironsight = false
			else
				inspectTimer = 0
			end
		end

		if selectfire == 1 then
			selectfireText = "Full"
		elseif selectfire == 2 then
			selectfireText = "Semi"
		else
			selectfireText = "Safe"
		end

		if shootTimer <= 0 then
			if recoilAngle > 0 then
				recoilAngle = recoilAngle - 0.1*recoilAngle - 0.1
			elseif recoilAngle < 0 then
				recoilAngle = 0

			end
			if rnd1 > 0 then
				rnd1 = rnd1 - 0.1
			elseif rnd1 <= 0 then
				rnd1 = 0
			end
			if rnd2 > 0 then
				rnd2 = rnd2 - 0.1
			elseif rnd2 <= 0 then
				rnd2 = 0
			end
			if rnd3 > 0 then
				rnd3 = rnd3 - 0.1
			elseif rnd3 <= 0 then
				rnd3 = 0
			end
		end

		if ironsight then
			recoilFactor = 2.5*stockFactor
		else
			recoilFactor = 5*stockFactor
		end

		if ironsight then
			recoilMax = 10*muzzleFactor*gripfactory*barrelFactory*stockFactor
		else
			recoilMax = 25*muzzleFactor*gripfactory*barrelFactory*stockFactor
		end

		if toprail == "scope" and not (q or e) then
			spreadFactor = 1
		elseif toprail == "holo" and not (q or e) then
			spreadFactor = 1.75
		else
			spreadFactor = 2
		end

		toprail = GetString("savegame.mod.toprail")
		muzzle = GetString("savegame.mod.muzzle")
		stock = GetString("savegame.mod.stock")
		if maginTimer > 0 then
			mag = GetString("savegame.mod.mag")
		end
		grip = GetString("savegame.mod.grip")
		barrel = GetString("savegame.mod.barrel")
		side = GetString("savegame.mod.side")
		ammotype = GetString("savegame.mod.ammotype")
		if ammotype == "" then
			SetString("savegame.mod.ammotype", "Buckshot")
			maxMomentum = 0.8
			pelletSpread = 5
			pelletAmount = 8
			pelletDamage = damage
		elseif ammotype == "Birdshot" then
			maxMomentum = 0.7
			pelletSpread = 13
			pelletAmount = 16
			pelletDamage = damage*0.8
		elseif ammotype == "Slugs" then
			maxMomentum = 1
			pelletSpread = 0.1
			pelletAmount = 2
			pelletDamage = damage*2
		else
			maxMomentum = 0.8
			pelletSpread = 5
			pelletAmount = 8
			pelletDamage = damage
		end

		for key, shell in ipairs(casing.shells) do
			if shell.active then
				Bouncing(shell)
				local rot = QuatEuler(90, shell[6], 0)
				local transform = Transform(shell.pos, rot)
				DrawSprite(spentcasing.sprite, transform, 0.4, 0.4, 0.35, 0.35, 0.35, 1, true, false)
			end
		end

		local b = GetToolBody()
		if b ~= 0 then
			local magoffset = Vec(0, 0, 0)
			local grenadeoffset = Vec(-0.025, 0.025, 0)
			local boltoffset = Vec(0, 0, 0)
			local selectoroffset = Transform()
			local suppressoroffset = Transform()
			local scopeoffset = Transform()
			local holooffset = Transform()
			local holooffset2 = Transform()
			local railoffset = Transform()
			local magtimer = magoutTimer + maginTimer
			offset = Transform(Vec(0, heightOffset, 0))
			local x, y, z, rot = 0.275, 0, 0, 0
			local adsFOV, adsTime = 0, 0
			local defaultTrans = Transform(Vec(0.25, 0.15, 0.25), QuatEuler(0, 0, 0))

			if grenadelauncher then
				x = 0
				y = 0.45
				z = 0.5
				rot = 0
			elseif q then
				x = 0.8
				y = 0.15
				z = 0.5
				rot = 30
			elseif e then
				x = -0.1
				y = 0.45
				z = 0.5
				rot = -15
			else
				if toprail == "holo" then
					x = 0.275
					y = 0.2625
					z = 0.5
					rot = 0
				elseif toprail == "" then
					x = 0.275
					y = 0.325
					z = 0.5
					rot = 0
				elseif toprail == "scope" then
					x = 0.275
					y = 0.25
					z = 0.5
					rot = 0
				end
			end

			if reloading then
				adsFOV, adsTime = 0, 0.15
			elseif not (q or e or grenadelauncher) then
				if toprail == "" then
					adsFOV, adsTime = 10, 0.15
				elseif toprail == "scope" then
					adsFOV, adsTime = 80, 0.25
				elseif toprail == "holo" then
					adsFOV, adsTime = 20, 0.1
				end
			elseif grenadelauncher then
				adsFOV, adsTime = 10, 0.15
			else
				adsFOV, adsTime = 0, 0.15
			end

			offset = ADS(ironsight, adsFOV, adsTime, -x, y, z, rot)

			if ironsight then
				btrans = GetBodyTransform(b)
				if toprail == "holo" then
					holopoint = TransformToParentTransform(btrans, Transform(Vec(0.275, -0.2625, -1.45), QuatEuler(0, 180, 0)))
					reticle1 = LoadSprite("MOD/img/reticle1.png")
					DrawSprite(reticle1, holopoint, 0.025, 0.025, 1, 0, 0, 1, true, true)
				end
				if toprail == "scope" then
					scopepoint = TransformToParentTransform(btrans, Transform(Vec(0.275, -0.252, -1.45), QuatEuler(0, 180, 0)))
					reticle2 = LoadSprite("MOD/img/reticle2.png")
					DrawSprite(reticle2, scopepoint, 0.075, 0.075, 1, 1, 1, 1, true, true)
				end
			end

			local speed = VecLength(GetPlayerVelocity())
			if speed > 1 then
				swayy = math.sin(GetTime()*20*speed/7)
				swayx = math.sin(GetTime()/reloadFactor*speed)
				offset.rot = QuatRotateQuat(offset.rot, QuatEuler(swayy*speed/10, swayx*speed/12, 0))
			end

			if meleeTimer > 0 then
				if meleeTimer > 0.6 then
					offset.rot = QuatEuler(0, (0.8-meleeTimer)*800, (0.8-meleeTimer)*50)
					offset.pos = VecAdd(offset.pos, Vec((0.8-meleeTimer)*1, (0.8-meleeTimer)*-1, (0.8-meleeTimer)*-7.5))
				elseif meleeTimer > 0.4 then
					offset.rot = QuatEuler(0, 160, 0)
					offset.pos = VecAdd(offset.pos, Vec(0.4+(meleeTimer-0.4)*1.5, 0, -2.5+(meleeTimer-0.4)*-1.5))
					stockPos = TransformToParentPoint(GetBodyTransform(GetToolBody()), Vec(0, -0.5, -0.65))
					if meleeTimer > 0.55 then
						if GetShapeMaterialAtPosition(shape, stockPos) == "glass" and math.random() > 0.8 then
							MakeHole(stockPos, 1)
						else
							MakeHole(stockPos, 0.3)
						end
					end
				else
					offset.rot = QuatEuler(0, meleeTimer*400, meleeTimer*100)
					offset.pos = VecAdd(offset.pos, Vec(0, 0, meleeTimer*-5))
				end

				meleeTimer = meleeTimer - dt
			end

			if selectfireTimer > 0 then
				selectfireTimer = selectfireTimer - dt
			end

			if inspectTimer > 0 then
				inspectTimer = inspectTimer - dt
			end

			if recoilTimer > 0 then
				offset.pos = VecAdd(offset.pos, Vec(0, 0, recoilTimer))
				offset.rot = QuatRotateQuat(offset.rot, QuatEuler((recoilTimer-0.02)*20, 0, 0))
				
				recoilTimer = recoilTimer - dt
				boltoffset = Vec(-0.01, 0, recoilTimer*1.25)
			end
			offset.pos = VecAdd(offset.pos, Vec(0, (recoilAngle/-100), 0))
			offset.rot = QuatRotateQuat(offset.rot, QuatEuler(recoilAngle + rnd1/2, rnd2/2, rnd3/2))

			if lightTimer > 0 then
				PointLight(toolPos, 1, 0.75, 0.25, (lightTimer/shotDelay)*lightFactor)
				lightTimer = lightTimer - dt
			end

			if magoutTimer < 0 then
				maginTimer = 0.6
				magoutTimer = 0
				reloadsound2playing = false
			end
			if maginTimer < 0.1 and not reloadsound2playing then
					PlaySound(reloadsound2, GetPlayerTransform().pos, 0.5, false)
					reloadsound2playing = true
			end
			if maginTimer < 0 then
				maginTimer = 0
				if grenadelauncher then
					PlaySound(uiselect, GetPlayerTransform().pos, 1)
				end
			end
			if magoutTimer > 0 then
				if grenadelauncher then
					grenadeoffset = Vec(-0.025, -magoutTimer*3+0.025, -0.6)
				else
					if magoutTimer >= 0.3 then
						magoffset = Vec(0, 0, -(0.6-magoutTimer)*1.5)
					elseif magoutTimer < 0.3 then
						magoffset = Vec(0, -(0.3-magoutTimer)*6, -0.45)
					
					end
				end
				magoutTimer = magoutTimer - dt/reloadFactor
			end
			if maginTimer > 0 then
				if grenadelauncher then
					grenadeoffset = Vec(-0.025, 0.025, -maginTimer)
				else
					if maginTimer >= 0.1 then
						magoffset = Vec(0, -(maginTimer-0.1)*4, -0.45)
					elseif maginTimer < 0.1 then
						magoffset = Vec(0, 0, -(maginTimer)*4.5)
					end
				end
				maginTimer = maginTimer - dt/reloadFactor
			end
			if not grenadelauncher or (grenadelauncherammo == 0 and not reloading) then
				grenadeoffset = Vec(0, 0, 1000)
			end

			local x1, y1, z1, rotx1, roty1, rotz1 = 0, 0, 0, 0, 0, 0
			if grenadelauncher then
					x1, y1, z1, rotx1, roty1, rotz1 = 0.1, -0.2, 0, 10, 5, -10
			elseif ironsight then
				if q then
					if magoutTimer > 0 then
						x1, y1, z1, rotx1, roty1, rotz1 = 0.1, 0.1, 0, -5, 10, -10
					elseif maginTimer > 0 or reloadTimer > 0.8 then
						x1, y1, z1, rotx1, roty1, rotz1 = 0, 0, 0, -5, 10, 0
					elseif reloadTimer < 0.8 and ammo == 0 then
						x1, y1, z1, rotx1, roty1, rotz1 = 0.25, -0.1, 0, 20, -20, -20
					end
				elseif e then
					if magoutTimer > 0 then
						x1, y1, z1, rotx1, roty1, rotz1 = 0, -0.05, 0, 10, -10, 10
					elseif maginTimer > 0 or (reloadTimer > 0.6 and ammo > 0) then
						x1, y1, z1, rotx1, roty1, rotz1 = 0, 0, 0, 5, -5, 0
					elseif reloadTimer < 0.8 and ammo == 0 then
						x1, y1, z1, rotx1, roty1, rotz1 = -0.75, -0.5, 0, 10, 0, 50
					end
				else
					if magoutTimer > 0 then
						x1, y1, z1, rotx1, roty1, rotz1 = 0.1, -0.05, 0, 0, 0, -10
					elseif maginTimer > 0 or (reloadTimer > 0.4 and ammo > 0) or (reloadTimer > 1 and ammo == 0) then
						x1, y1, z1, rotx1, roty1, rotz1 = 0.1, -0.05, 0, 0, 0, -10
					elseif reloadTimer < 0.8 and ammo == 0 then
						x1, y1, z1, rotx1, roty1, rotz1 = -0.3, 0.1, -0.1, -10, -5, 10
					else
						x1, y1, z1, rotx1, roty1, rotz1 = -0.05, 0, 0, 0, 0, 0
					end
				end
			else
				if magoutTimer > 0 then
					x1, y1, z1, rotx1, roty1, rotz1 = 0, 0.05, 0, 10, -10, -10
				elseif maginTimer > 0 or (reloadTimer > 0.6 and ammo > 0) then
					x1, y1, z1, rotx1, roty1, rotz1 = 0, 0, 0, 5, 0, -5
				elseif reloadTimer < 0.8 and ammo == 0 then
					x1, y1, z1, rotx1, roty1, rotz1 = -0.75, -0.5, 0, 10, 0, 50
				end
			end

			RELoffset = REL(reloading, x1, y1, z1, rotx1, roty1, rotz1)
			offset.pos = VecAdd(offset.pos, RELoffset.pos)
			offset.rot = QuatRotateQuat(offset.rot, RELoffset.rot)

			if reloadTimer < 0.5 and reloadTimer > 0.2 and reloading and ammo == 0 then
				boltoffset = Vec(-0.01, 0, (0.5-reloadTimer)*0.75)
			end

			if selectattachmentsTimer > 0 and selectattachments then
				local t1 = (0.5 - selectattachmentsTimer)/0.5
				offset.pos = VecAdd(offset.pos, Vec(1*t1, 0, -0.8*t1*180/GetInt("options.gfx.fov")))
				offset.rot = QuatRotateQuat(offset.rot, QuatEuler(10*t1, 75*t1, -10*t1))
			elseif selectattachmentsTimer > 0 and not selectattachments then
				local t2 = selectattachmentsTimer/0.25
				offset.pos = VecAdd(offset.pos, Vec(1*t2, 0, -0.8*t2*180/GetInt("options.gfx.fov")))
				offset.rot = QuatRotateQuat(offset.rot, QuatEuler(10*t2, 75*t2, -10*t2))
			elseif selectattachments then
				offset.pos = VecAdd(offset.pos, Vec(1, 0, -0.8*180/GetInt("options.gfx.fov")))
				offset.rot = QuatRotateQuat(offset.rot, QuatEuler(10, 75, -10))
			end

			if selectattachmentsTimer > 0 then
				selectattachmentsTimer = selectattachmentsTimer*0.9 - dt/20
			elseif selectattachmentsTimer < 0 then
				selectattachmentsTimer = 0
			end

			local x2, y2, z2, rotx2, roty2, rotz2 = 0, 0, 0, 0, 0, 0
			if inspectTimer > 4 then
				x2, y2, z2, rotx2, roty2, rotz2 = 1, 0, -0.75, 10, 75, -10
			elseif inspectTimer > 3 then
				x2, y2, z2, rotx2, roty2, rotz2 = 1, 0, -0.75, 10, 75, -20
			elseif inspectTimer > 1.25 then
				x2, y2, z2, rotx2, roty2, rotz2 = 0.25, -1, 0, 20, 30, 120
			elseif inspectTimer > 0 then
				x2, y2, z2, rotx2, roty2, rotz2 = 0.25, -0.25, 0.25, 20, 30, 0
			end

			INSoffset = INS(inspectTimer > 0, x2, y2, z2, rotx2, roty2, rotz2)
			offset.pos = VecAdd(offset.pos, INSoffset.pos)
			offset.rot = QuatRotateQuat(offset.rot, INSoffset.rot)

			local x3, y3, z3, rotx3, roty3, rotz3 = 0, 0, 0, 0, 0, 0
			if (selectfire == 0 or InputDown("shift")) and selectfireTimer <= 0 then
				x3, y3, z3, rotx3, roty3, rotz3 = 0.4, 0.4, -0.2, -20, 60, 0
			elseif ironsight and q and selectfireTimer > 0 then
				x3, y3, z3, rotx3, roty3, rotz3 = 0, 0, 0, 0, 0, 0
			elseif ironsight and selectfireTimer > 0  then
				x3, y3, z3, rotx3, roty3, rotz3 = -0.25, -0.1, 0, 0, 5, 30
			elseif selectfireTimer > 0 then
				x3, y3, z3, rotx3, roty3, rotz3 = -0.4, -0.3, 0.25, 0, 5, 50
			else
				x3, y3, z3, rotx3, roty3, rotz3 = 0, 0, 0, 0, 0, 0
			end

			SELoffset = SEL(selectfireTimer > 0 or selectfire == 0 or InputDown("shift"), x3, y3, z3, rotx3, roty3, rotz3)
			offset.pos = VecAdd(offset.pos, SELoffset.pos)
			offset.rot = QuatRotateQuat(offset.rot, SELoffset.rot)

			SetToolTransform(offset)
			toolTrans = GetBodyTransform(b)
			toolPos = TransformToParentPoint(toolTrans, Vec(0.275, -0.6, -2.6))

			if body ~= b then
				body = b
				local shapes = GetBodyShapes(b)
				mag0 = shapes[2]
				bolt = shapes[3]
				selector = shapes[4]
				suppressor = shapes[5]
				scope = shapes[6]
				holo = shapes[7]
				holo2 = shapes[8]
				rail = shapes[9]
				stock1 = shapes[10]
				muzzlebreak = shapes[11]
				muzzlebreak2 = shapes[12]
				mag1 = shapes[13]
				mag2 = shapes[14]
				mag3 = shapes[15]
				grip1 = shapes[16]
				grip1_2 = shapes[17]
				grip2 = shapes[18]
				grip3 = shapes[22]
				grip3_1 = shapes[23]
				grip3_2 = shapes[24]
				grip4 = shapes[25]
				barrel0 = shapes[19]
				barrel1 = shapes[20]
				barrel2 = shapes[21]
				side1 = shapes[26]
				side2 = shapes[27]
				side3 = shapes[28]
				grenade = shapes[29]
				magTrans = GetShapeLocalTransform(mag0)
				boltTrans = GetShapeLocalTransform(bolt)
				selectorTrans = GetShapeLocalTransform(selector)
				suppressorTrans = GetShapeLocalTransform(suppressor)
				scopeTrans = GetShapeLocalTransform(scope)
				holoTrans = GetShapeLocalTransform(holo)
				holoTrans2 = GetShapeLocalTransform(holo2)
				railTrans = GetShapeLocalTransform(rail)
				stock1Trans = GetShapeLocalTransform(stock1)
				muzzlebreakTrans = GetShapeLocalTransform(muzzlebreak)
				muzzlebreakTrans2 = GetShapeLocalTransform(muzzlebreak2)
				gripTrans = GetShapeLocalTransform(grip1)
				barrelTrans0 = GetShapeLocalTransform(barrel0)
				barrelTrans1 = GetShapeLocalTransform(barrel1)
				barrelTrans2 = GetShapeLocalTransform(barrel2)
				sideTrans1 = GetShapeLocalTransform(side1)
				sideTrans2 = GetShapeLocalTransform(side2)
				sideTrans3 = GetShapeLocalTransform(side3)
				grenadeTrans = GetShapeLocalTransform(grenade)
			end

			mt = TransformCopy(magTrans)
			mt.pos = VecAdd(mt.pos, magoffset)

			bt = TransformCopy(boltTrans)
			bt.pos = VecAdd(bt.pos, boltoffset)

			st = TransformCopy(selectorTrans)
			st.pos = VecAdd(st.pos, selectoroffset)

			spt = TransformCopy(suppressorTrans)
			spt.pos = VecAdd(spt.pos, suppressoroffset)

			sct = TransformCopy(scopeTrans)
			sct.pos = VecAdd(sct.pos, scopeoffset)

			ht = TransformCopy(holoTrans)
			ht.pos = VecAdd(ht.pos, holooffset)
			ht2 = TransformCopy(holoTrans2)
			ht2.pos = VecAdd(ht.pos, holooffset)

			rt = TransformCopy(railTrans)
			rt.pos = VecAdd(rt.pos, railoffset)

			stt = TransformCopy(stock1Trans)
			stt.pos = VecAdd(stt.pos, stock1offset)

			mbt = TransformCopy(muzzlebreakTrans)
			mbt.pos = VecAdd(mbt.pos, muzzlebreakoffset)
			mbt2 = TransformCopy(muzzlebreakTrans2)
			mbt2.pos = VecAdd(mbt2.pos, muzzlebreakoffset2)

			gt1 = TransformCopy(gripTrans)
			gt1.pos = VecAdd(gt1.pos, gripoffset)
			gt1_2 = TransformCopy(gripTrans)
			gt1_2.pos = VecAdd(gt1_2.pos, gripoffset)

			gt2 = TransformCopy(gripTrans)
			gt2.pos = VecAdd(gt2.pos, gripoffset)

			gt3 = TransformCopy(gripTrans)
			gt3.pos = VecAdd(gt3.pos, gripoffset)
			gt3_1 = TransformCopy(gripTrans)
			gt3_1.pos = VecAdd(gt3_1.pos, gripoffset)
			gt3_2 = TransformCopy(gripTrans)
			gt3_2.pos = VecAdd(gt3_2.pos, gripoffset)

			glt = TransformCopy(gripTrans)
			glt.pos = VecAdd(glt.pos, gripoffset)

			bt0 = TransformCopy(barrelTrans0)
			bt0.pos = VecAdd(bt0.pos, barreloffset)

			bt1 = TransformCopy(barrelTrans1)
			bt1.pos = VecAdd(bt1.pos, barreloffset)

			bt2 = TransformCopy(barrelTrans2)
			bt2.pos = VecAdd(bt2.pos, barreloffset)

			sdt1 = TransformCopy(sideTrans1)
			sdt1.pos = VecAdd(sdt1.pos, sideoffset)
			sdt2 = TransformCopy(sideTrans2)
			sdt2.pos = VecAdd(sdt2.pos, sideoffset)
			sdt3 = TransformCopy(sideTrans3)
			sdt3.pos = VecAdd(sdt3.pos, sideoffset)

			grt = TransformCopy(grenadeTrans)
			grt.pos = VecAdd(grt.pos, grenadeoffset)

			if not grenadelauncher then
				if magoutTimer > 0 then
					mt.rot = QuatRotateQuat(mt.rot, QuatEuler((0.6-magoutTimer)*120, 0, 0))
				elseif maginTimer > 0.1 then
					mt.rot = QuatRotateQuat(mt.rot, QuatEuler(30, 0, 0))
				elseif maginTimer > 0 then
					mt.rot = QuatRotateQuat(mt.rot, QuatEuler(maginTimer*300, 0, 0))
				end
			end

			if selectfireTimer < 0.4 then
				if selectfire == 1 then
					st.rot = QuatEuler(-90, 0, 0)
				elseif selectfire == 2 then
					st.rot = QuatEuler(-100, 0, 0)
				else
					st.rot = QuatEuler(-70, 0, 0)
				end
			elseif selectfireTimer > 0 then
				if selectfire0 == 1 then
					st.rot = QuatEuler(-90, 0, 0)
				elseif selectfire0 == 2 then
					st.rot = QuatEuler(-105, 0, 0)
				else
					st.rot = QuatEuler(-70, 0, 0)
				end
			end

			if muzzle == "muzzle1" then
				spt.pos = VecAdd(spt.pos, Vec(0.075, 0, -barrellength))
				spt.rot = QuatEuler(-90, 0, 45)
				lightFactor = 0.4
			else
				spt.pos = Vec(0, 0, 1000)
				spt.rot = QuatEuler(0, 0, 0)
				lightFactor = 2
				muzzleFactor = 1
			end
			if muzzle == "muzzle2" then
				mbt.pos = VecAdd(mbt.pos, Vec(0.075, 0, -barrellength))
				mbt2.pos = VecAdd(mbt2.pos, Vec(0, 0.05, -barrellength))
				mbt.rot = QuatEuler(-90, 0, 45)
				lightFactor = 3
				muzzleFactor = 0.75
			else
				mbt.pos = Vec(0, 0, 1000)
				mbt2.pos = Vec(0, 0, 1000)
				mbt.rot = QuatEuler(0, 0, 0)
				lightFactor = 2
				muzzleFactor = 1
			end
			if toprail == "scope" then
				sct.pos = Vec(0.2, -0.425, -1.375)
			else
				sct.pos = Vec(0, 0, 1000)
			end
			if toprail == "holo" then
				ht.pos = Vec(0.175, -0.425, -1.375)
				ht2.pos = Vec(0.225, -0.35, -1.375)
			else
				ht.pos = Vec(0, 0, 1000)
				ht2.pos = Vec(0, 0, 1000)
			end
			if stock == "removed" then
				stt.pos = Vec(0.2, -0.95, -1.3)
				stt.rot = QuatEuler(-90, 180, 0)
				stockFactor = 2.5
			else
				stt.pos = Vec(0.2, -0.95, 0.2)
				stt.rot = QuatEuler(-90, 0, 0)
				stockFactor = 1
			end
			rt.pos = Vec(0.175, -0.725, -0.625)

			if mag == "" then
				magsize = 5
				reloadFactor = 1
				SetShapeLocalTransform(mag0, mt)
				SetShapeLocalTransform(mag1, Transform(Vec(0, 0, 1000)))
				SetShapeLocalTransform(mag2, Transform(Vec(0, 0, 1000)))
				SetShapeLocalTransform(mag3, Transform(Vec(0, 0, 1000)))
			elseif mag == "mag1" then
				magsize = 10
				reloadFactor = 1.25
				SetShapeLocalTransform(mag1, Transform(VecAdd(mt.pos, Vec(0, -0.1, 0)), mt.rot))
				SetShapeLocalTransform(mag0, Transform(Vec(0, 0, 1000)))
				SetShapeLocalTransform(mag2, Transform(Vec(0, 0, 1000)))
				SetShapeLocalTransform(mag3, Transform(Vec(0, 0, 1000)))
			elseif mag == "mag2" then
				magsize = 20
				reloadFactor = 1.75
				SetShapeLocalTransform(mag2, Transform(VecAdd(mt.pos, Vec(-0.15, 0.1, 0)), mt.rot))
				SetShapeLocalTransform(mag0, Transform(Vec(0, 0, 1000)))
				SetShapeLocalTransform(mag1, Transform(Vec(0, 0, 1000)))
				SetShapeLocalTransform(mag3, Transform(Vec(0, 0, 1000)))
			elseif mag == "mag3" then
				magsize = 95
				reloadFactor = 2.25
				SetShapeLocalTransform(mag3, Transform(VecAdd(mt.pos, Vec(-0.45, 0.15, 0)), mt.rot))
				SetShapeLocalTransform(mag0, Transform(Vec(0, 0, 1000)))
				SetShapeLocalTransform(mag1, Transform(Vec(0, 0, 1000)))
				SetShapeLocalTransform(mag2, Transform(Vec(0, 0, 1000)))
			end

			if grip == "grip1" then
				gripfactorx = 0.85
				gripfactory = 0.6
				gt1.pos = Vec(0.2, -0.85, -1.575)
				gt1_2.pos = Vec(0.225, -0.95, -1.6)
			else
				gt1.pos = Vec(0, 0, 1000)
				gt1_2.pos = Vec(0, 0, 1000)
			end
			if grip == "grip2" then
				gripfactorx = 0.6
				gripfactory = 0.85
				gt2.pos = Vec(0.25, -0.9, -1.5)
			else
				gt2.pos = Vec(0, 0, 1000)
			end
			if grip == "grip3" then
				local querypos = TransformToParentPoint(GetBodyTransform(GetToolBody()), Vec(0.25, -0.6, -2-barrellength*4/3))
				local hit, dist = QueryRaycast(querypos, Vec(0, -2, 0), 5, 0.2)
				local bipodded = (InputDown("ctrl") or dist < 0.4) and selectfire > 0
				if bipodded then
					gripfactorx = 0.4
					gripfactory = 0.4
					gt3_1.pos = Vec(0.4, -1.35, -2.05-barrellength*4/3)
					gt3_2.pos = Vec(0.05, -1.325, -2.05-barrellength*4/3)
					gt3_1.rot = QuatEuler(0, 0, 10)
					gt3_2.rot = QuatEuler(0, 0, -10)
				else
					gripfactorx = 1
					gripfactory = 1
					if barrel == "barrel2" then
						gt3_1.pos = Vec(0.3, -0.725, -1.3-barrellength)
						gt3_2.pos = Vec(0.15, -0.725, -1.3-barrellength)
					else
						gt3_1.pos = Vec(0.3, -0.675, -2.75-barrellength)
						gt3_2.pos = Vec(0.15, -0.675, -2.75-barrellength)
						gt3_1.rot = QuatEuler(90, 0, 0)
						gt3_2.rot = QuatEuler(90, 0, 0)
					end
					
				end
				gt3.pos = Vec(0.225, -0.725, -1.95-barrellength)
				
			else
				gt3.pos = Vec(0, 0, 1000)
				gt3_1.pos = Vec(0, 0, 1000)
				gt3_2.pos = Vec(0, 0, 1000)
			end
			if grip == "grenade_launcher" then
				gripfactorx = 1.1
				gripfactory = 1.1
				glt.pos = Vec(0.2, -0.9, -1.4)
			else
				glt.pos = Vec(0, 0, 1000)
			end
			if grip == "" then
				gripfactorx = 1
				gripfactory = 1
			end

			if barrel == "" then
				barrelFactorx = 1
				barrelFactory = 1
				barrelFactordamage = 1
				accuracyFactor = 0.9
				barrelFactorspread = 1
				barrellength = 0.25
				bt1.pos = bt1.pos
			else
				bt1.pos = Vec(0, 0, 1000)
			end
			if barrel == "barrel1" then
				barrelFactorx = 1.2
				barrelFactory = 0.8
				barrelFactordamage = 1
				accuracyFactor = 1.1
				barrelFactorspread = 1.3
				barrellength = 0
				bt0.pos = bt0.pos
			else
				bt0.pos = Vec(0, 0, 1000)
			end
			if barrel == "barrel2" then
				barrelFactorx = 0.8
				barrelFactory = 1.3
				barrelFactordamage = 1.2
				accuracyFactor = 0.7
				barrelFactorspread = 0.8
				barrellength = 0.75
				bt2.pos = bt2.pos
			else
				bt2.pos = Vec(0, 0, 1000)
			end

			if side == "side1" then
				sdt1.pos = sdt1.pos
			else
				sdt1.pos = Vec(0, 0, 1000)
			end
			if side == "side2" then
				sdt2.pos = sdt2.pos
			else
				sdt2.pos = Vec(0, 0, 1000)
			end
			if side == "side3" then
				sdt3.pos = sdt3.pos
			else
				sdt3.pos = Vec(0, 0, 1000)
			end

			if mag == "mag2" or mag == "mag3" then
				SetString("savegame.mod.stock", "")
			end

			SetShapeLocalTransform(bolt, bt)
			SetShapeLocalTransform(selector, st)
			SetShapeLocalTransform(suppressor, spt)
			SetShapeLocalTransform(scope, sct)
			SetShapeLocalTransform(holo, ht)
			SetShapeLocalTransform(holo2, ht2)
			SetShapeLocalTransform(rail, rt)
			SetShapeLocalTransform(stock1, stt)
			SetShapeLocalTransform(muzzlebreak, mbt)
			SetShapeLocalTransform(muzzlebreak2, mbt2)
			SetShapeLocalTransform(grip1, gt1)
			SetShapeLocalTransform(grip1_2, gt1_2)
			SetShapeLocalTransform(grip2, gt2)
			SetShapeLocalTransform(grip3, gt3)
			SetShapeLocalTransform(grip3_1, gt3_1)
			SetShapeLocalTransform(grip3_2, gt3_2)
			SetShapeLocalTransform(grip4, glt)
			SetShapeLocalTransform(barrel0, bt0)
			SetShapeLocalTransform(barrel1, bt1)
			SetShapeLocalTransform(barrel2, bt2)
			SetShapeLocalTransform(side1, sdt1)
			SetShapeLocalTransform(side2, sdt2)
			SetShapeLocalTransform(side3, sdt3)
			SetShapeLocalTransform(grenade, grt)
		end

		if selectattachments then
			clickedmag = clickedmag1 or clickedmag2 or clickedmag3
			if clickedmag and selectattachments and not InputPressed("t") then
				Reload()
			end
		end
		if reloading and not clickedmag and selectattachments then
			selectattachments = false
			selectattachmentsTimer = 0.25
		end

		if not selectattachments then
			if (InputPressed("R") or clickedmag) and selectfireTimer == 0 then
				if (ammo ~= magsize + 1 and not grenadelauncher) or (grenadelauncherammo == 0 and grenadelauncher) then
					Reload()
					inspectTimer = 0
				end
			end
			
			if GetBool("ammobox.refill") then
				SetBool("ammobox.refill", false)
				mags = mags + 1
				PlaySound(refillsound, GetPlayerTransform().pos, 1, false)
			end

			if reloading then
				if reloadTimer > 0.5 then
					reloadTimer = reloadTimer - dt/reloadFactor
				elseif reloadTimer > 0 then
					reloadTimer = reloadTimer - dt
				end
				if reloadTimer < 0.5 and not cocksoundplaying and ammo == 0 then
					cocksoundplaying = true
					PlaySound(cocksound, GetPlayerTransform().pos, 0.85)
				end
				if reloadTimer < 0 then
					cocksoundplaying = false
					if grenadelauncher then
						grenadelauncherammo = 1
					else
						if ammo == 0 then
							ammo = magsize
						else
							ammo = magsize + 1
						end
					end
					reloadTimer = 0
					reloading = false
				end
			end

			if selectfireTimer < 0.55 and selectfireTimer > 0 and not selectsoundplaying then
				selectsoundplaying = true
				PlaySound(selectsound, GetPlayerTransform().pos, 0.85)
			end
			if selectfireTimer < 0 then
				selectsoundplaying = false
				selectfireTimer = 0
			end
			
		end

		btrans = GetBodyTransform(b)
		sightattachpoint = TransformToParentPoint(btrans, Vec(0.25, -0.15, -1))
		muzzleattachpoint = TransformToParentPoint(btrans, Vec(0.25, -0.35, -2.5))
		stockattachpoint = TransformToParentPoint(btrans, Vec(0.25, -0.4, -0.6))
		sideattachpoint = TransformToParentPoint(btrans, Vec(0.1, -0.45, -1.65))
		magattachpoint = TransformToParentPoint(btrans, Vec(0.25, -0.65, -1))
		gripattachpoint = TransformToParentPoint(btrans, Vec(0.1, -0.85, -1.4))
		barrelattachpoint = TransformToParentPoint(btrans, Vec(0.1, -0.65, -1.6))
		ammoattachpoint = TransformToParentPoint(btrans, Vec(0.25, -0.8, -0.75))

		for key, shell in ipairs(ak47projectileHandler.shells) do
			if shell.active then
				ProjectileOperations(shell)
			end
		end
		for key, shell in ipairs(ak47grenadeHandler.shells) do
			if shell.active then
				GrenadeOperations(shell)
			end
		end
	
		if shootTimer > 0 or ammo == 0 then
			shootTimer = shootTimer - dt
		end
	end
end

function draw()
	if GetString("game.player.tool") == "saiga12" and GetPlayerVehicle() == 0 then
		if not unlimitedammo then
			UiPush()
				UiTranslate(UiCenter(), UiHeight()-60)
				UiAlign("center middle")
				UiColor(1, 1, 1)
				UiFont("bold.ttf", 32)
				UiTextOutline(0,0,0,1,0.1)
				if reloading then
					UiText("Reloading")
				elseif grenadelauncher then
					UiText(grenadelauncherammo.."/1 - Grenade")
				else
					UiText(ammo.."/"..magsize*math.max(0, mags-1).." - "..selectfireText)
				end
			UiPop()
		else
			UiPush()
				UiTranslate(UiCenter(), UiHeight()-60)
				UiAlign("center middle")
				UiColor(1, 1, 1)
				UiFont("bold.ttf", 32)
				UiTextOutline(0,0,0,1,0.1)
				if reloading then
					UiText("Reloading")
				elseif grenadelauncher then
					UiText(grenadelauncherammo.."/1 - Grenade")
				else
					UiText("Infinite")
				end
			UiPop()
		end
	end
	if GetString("game.player.tool") == "saiga12" and grenadelauncher and not selectattachments then
		UiPush()
			UiTranslate(UiCenter(), UiMiddle())
			UiAlign("center middle")
			UiImage("ui/hud/crosshair-launcher.png")
		UiPop()
	end
	if GetString("game.player.tool") == "saiga12" and sideattachment and side == "side3" then
		UiPush()
			local x,y,dist = UiWorldToPixel(sideattachpoint)
			UiTranslate(x, y)
			UiAlign("center middle")
			UiColor(1, 0.1, 0.1)
			UiFont("bold.ttf", 32)
			UiTextOutline(0,0,0,1,0.1)
			UiText(math.floor(range))
		UiPop()
	end

	if selectattachments then
	if hint then drawHint(info) end
	hoverindex=0
		UiPush()
			local x,y,dist=UiWorldToPixel(sightattachpoint)
			if dist > 0 then
				UiTranslate(x-50,y+20)
				local curx,cury=UiGetRelativePos()
				UiPush()
					UiAlign("center middle")
					clickedscope = AttachmentButton("toprail","scope",true,{curx,cury},{"Scope","3x magnification sight for medium range combat."})
					UiTranslate(-70,0)
					curx,cury=curx-70,cury
					clickedholo = AttachmentButton("toprail","holo",true,{curx,cury},{"Holographic Sight","1x magnification sight for close range combat."})
					UiTranslate(-70,0)
				UiPop()
			end
		UiPop()
		UiPush()
			local x,y,dist=UiWorldToPixel(muzzleattachpoint)
			if dist > 0 then
				UiTranslate(x-50,y+20)
				local curx,cury=UiGetRelativePos()
				UiPush()
					UiAlign("center middle")
					clickedmuzzle1 = AttachmentButton("muzzle","muzzle1",true,{curx,cury},{"Suppressor","Suppresses gun noise for sneaky combat."})
					UiTranslate(-70,0)
					curx,cury=curx-70,cury
					clickedmuzzle2 = AttachmentButton("muzzle","muzzle2",true,{curx,cury},{"Muzzle Break","Reduces recoil, but turns your barrel into a flashbang."})
					UiTranslate(-70,0)
				UiPop()
			end
		UiPop()
		UiPush()
			local x,y,dist=UiWorldToPixel(stockattachpoint)
			if dist > 0 then
				UiTranslate(x-50,y+20)
				local curx,cury=UiGetRelativePos()
				UiPush()
					if mag == "" or mag == "mag1" then
						UiAlign("center middle")
						clickedstockremoved = AttachmentButton("stock","removed",true,{curx,cury},{"Stock","Foldable for badasses only."})
						UiTranslate(-70,0)
					end
				UiPop()
			end
		UiPop()
		UiPush()
			local x,y,dist=UiWorldToPixel(sideattachpoint)
			if dist > 0 then
				UiTranslate(x-50,y+20)
				local curx,cury=UiGetRelativePos()
				UiPush()
					UiAlign("center middle")
					clickedside1 = AttachmentButton("side","side1",true,{curx,cury},{"Laser","A laser that points where you shoot."})
					UiTranslate(-70,0)
					curx,cury=curx-70,cury
					clickedside2 = AttachmentButton("side","side2",true,{curx,cury},{"Flashlight","Lights up the area in front of you."})
					UiTranslate(-70,0)
					curx,cury=curx-70,cury
					clickedside3 = AttachmentButton("side","side3",true,{curx,cury},{"Rangefinder","Displays the range to your target."})
					UiTranslate(-70,0)
				UiPop()
			end
		UiPop()
		UiPush()
			local x,y,dist=UiWorldToPixel(magattachpoint)
			if dist > 0 then
				UiTranslate(x-50,y+20)
				local curx,cury=UiGetRelativePos()
				UiPush()
					UiAlign("center middle")
					clickedmag1 = AttachmentButton("mag","mag1",true,{curx,cury},{"10rnd Mag","Pew Pew Pew"})
					UiTranslate(-70,0)
					curx,cury=curx-70,cury
					clickedmag2 = AttachmentButton("mag","mag2",true,{curx,cury},{"20rnd Drum","Pew Pew Pew Pew Pew Pew"})
					UiTranslate(-70,0)
					curx,cury=curx-70,cury
				UiPop()
			end
		UiPop()
		UiPush()
			local x,y,dist=UiWorldToPixel(gripattachpoint)
			if dist > 0 then
				UiTranslate(x-50,y+20)
				local curx,cury=UiGetRelativePos()
				UiPush()
					UiAlign("center middle")
					clickedgrip1 = AttachmentButton("grip","grip1",true,{curx,cury},{"Vertical Grip","Decreased vertical recoil."})
					UiTranslate(-70,0)
					curx,cury=curx-70,cury
					clickedgrip2 = AttachmentButton("grip","grip2",true,{curx,cury},{"Angled Grip","Decreased horizontal recoil."})
					UiTranslate(-70,0)
					curx,cury=curx-70,cury
				UiPop()
			end
		UiPop()
		UiPush()
			local x,y,dist=UiWorldToPixel(barrelattachpoint)
			if dist > 0 then
				UiTranslate(x-50,y+20)
				local curx,cury=UiGetRelativePos()
				UiPush()
					UiAlign("center middle")
					clickedbarrel1 = AttachmentButton("barrel","barrel1",true,{curx,cury},{"Short Barrel","Increased spread but less vertical recoil."})
					UiTranslate(-140,0)
					curx,cury=curx-70,cury
					clickedbarrel2 = AttachmentButton("barrel","barrel2",true,{curx,cury},{"Long Barrel","Increased accuracy and damage but more vertical recoil."})
					UiTranslate(-70,0)
				UiPop()
			end
		UiPop()
		UiPush()
			local x,y,dist=UiWorldToPixel(ammoattachpoint)
			if dist > 0 then
				UiTranslate(x-50,y+20)
				local curx,cury=UiGetRelativePos()
				UiPush()
					UiAlign("center middle")
					clickedammo1 = AttachmentButton("ammotype","Buckshot",true,{curx,cury},{"Buckshot","8 Pellets. Medium damage."})
					UiTranslate(-100,0)
					curx,cury=curx-70,cury
					clickedammo2 = AttachmentButton("ammotype","Birdshot",true,{curx,cury},{"Birdshot","16 Pellets. Low damage."})
					UiTranslate(-100,0)
					curx,cury=curx-70,cury
					clickedammo1 = AttachmentButton("ammotype","Slugs",true,{curx,cury},{"Slugs","1 Pellet. Pakcs a big punch"})
					UiTranslate(-100,0)
					curx,cury=curx-70,cury
					UiTranslate(-70,0)
				UiPop()
			end
		UiPop()
	end
	--if ironsight and not (q or e) and toprail == "holo" and fovTimer > 0.1 then
		--UiPush()
			--local gt = GetBodyTransform(GetToolBody())
			--local gunpos = TransformToParentPoint(gt, Vec(0.175, -0.525, -1.9))
			--local fwdpos = TransformToParentVec(gt, Vec(0, 0, -1))
			--local hit, dist = QueryRaycast(gunpos, fwdpos, 500)
			--local hitpoint = VecAdd(gunpos, VecScale(fwdpos, dist))
			--local imgx, imgy, dist = UiWorldToPixel(hitpoint)
			--UiTranslate(imgx, imgy)
			--UiAlign("center middle")
			--UiImage("MOD/icon/reticle1.png")
		--UiPop()
	--end
end